
//+-----------------------------------------------------------------------------------------------+
//|     DBB Short/Long Setup Indicator based on Chris`s Method                                    |
//|     See http://www.fxkeys.com/dbb-trading-system-rules-for-long-and-short-trade-setups/       |
//|                                  2014 - Singh ( networkjas@gmail.com)                         |
//+-----------------------------------------------------------------------------------------------+
 
//---- input parameters
extern int       TFup=3;
/*
extern int       bars_back=20;
extern bool      stats=false;
extern color     UpCandleColor=Green;
extern color     DownCandleColor=Salmon;
extern int       width = 3;
extern bool      filling=false;
*/

//---- internal parameters

int timeFrame[] = {1,5,15,30,60,240,1440,10080,43200};
string TimeFrames[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int nextTF;
color clr;


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+

void init() 

  {

for(int i=0;i<ArraySize(timeFrame);i++)

{
if(i==ArraySize(timeFrame)-TFup){nextTF=timeFrame[8];Print("Sorry maximum time frame reached");break;}
if(timeFrame[i]==Period()){nextTF=timeFrame[i+TFup];break;}

  }
   
  
  }

//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+


void deinit() 
{

  ObjectsDeleteAll();

  
}


//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+


int start()


  {
   
   
   
   //SINGH START
   double close_candle1 = iClose(NULL,0,1); 
   double close_candle2 = iClose(NULL,0,2); 
   double close_candle3 = iClose(NULL,0,3); 
   
   double open_candle1 = iOpen(NULL,0,1); 
   double open_candle2 = iOpen(NULL,0,2); 
   double open_candle3 = iOpen(NULL,0,3); 
   
   //iBands of last candle
   double iband1_candle1 = iBands (NULL,0,20,2,0,0,MODE_UPPER,1) ;
   double iband2_candle1 = iBands (NULL,0,20,1,0,0,MODE_UPPER,1) ;       
   double iband3_candle1 = iBands (NULL,0,20,2,0,0,MODE_MAIN,1) ;
   double iband4_candle1= iBands (NULL,0,20,1,0,0,MODE_LOWER,1)    ; 
   double iband5_candle1 = iBands (NULL,0,20,2,0,0,MODE_LOWER,1)   ; 
      
   //iBands of prev of last candle
   double iband1_candle2 = iBands (NULL,0,20,2,0,0,MODE_UPPER,2) ;
   double iband2_candle2 = iBands (NULL,0,20,1,0,0,MODE_UPPER,2) ;       
   double iband3_candle2 = iBands (NULL,0,20,2,0,0,MODE_MAIN,2) ;
   double iband4_candle2= iBands (NULL,0,20,1,0,0,MODE_LOWER,2)    ; 
   double iband5_candle2 = iBands (NULL,0,20,2,0,0,MODE_LOWER,2)   ; 

   //iBands of prev of prev of last candle
   double iband1_candle3 = iBands (NULL,0,20,2,0,0,MODE_UPPER,3) ;
   double iband2_candle3 = iBands (NULL,0,20,1,0,0,MODE_UPPER,3) ;       
   double iband3_candle3 = iBands (NULL,0,20,2,0,0,MODE_MAIN,3) ;
   double iband4_candle3= iBands (NULL,0,20,1,0,0,MODE_LOWER,3)    ; 
   double iband5_candle3 = iBands (NULL,0,20,2,0,0,MODE_LOWER,3)   ;          
   
   //CHECK IF THERE IS ANY LONG SETUP
   if((close_candle1<iband1_candle1) && (close_candle1>iband2_candle1)){
      if(open_candle1<iband2_candle1){
              
              //now check other two candles
              if(close_candle2<iband2_candle2){
                   if(open_candle3<iband2_candle3){
                            Comment (
                             "\n----------------------------------------------------------------------------------------"
                            ,"\nLONG SETUP DETECTED based on DBB method. God Bless Chris ! "
                            ,"\n----------------------------------------------------------------------------------------"
                            );
                   
                   }//endif
              }//endif
              
      }//endif   
   }//endif
   
   //CHECK IF THERE IS ANY SHORT SETUP
   if((close_candle1<iband4_candle1) && (close_candle1>iband5_candle1)){
      if(open_candle1<iband3_candle1){
              
              //now check other two candles
              if(close_candle2>iband4_candle2){
                   if(open_candle3>iband4_candle3){
                            Comment (
                             "\n----------------------------------------------------------------------------------------"
                            ,"\nSHORT SETUP DETECTED based on DBB method. God Bless Chris ! "
                            ,"\n----------------------------------------------------------------------------------------"
                            );
                   
                   }//endif
              }//endif
              
      }//endif   
   }//endif   
   
    
    /*  For debugging
   Comment (
    "close_candle1 : ",close_candle1, 
    "\nclose_candle2 : ",close_candle2, 
    "\nclose_candle3 : ",close_candle3,
    
    "\nOpen_candle1 : ",open_candle1,     
    "\nOpen_candle2 : ",open_candle2, 
    "\nOpen_candle3 : ",open_candle3         
    
    ,"\n Band 1 : ", iBands (NULL,0,20,2,0,0,MODE_UPPER,2) 
    ,"\n Band 2 : ", iBands (NULL,0,20,1,0,0,MODE_UPPER,0)         
    ,"\n Band 3  : ", iBands (NULL,0,20,2,0,0,MODE_MAIN,0) 
    ,"\n Band 4 : ", iBands (NULL,0,20,1,0,0,MODE_LOWER,0)     
    ,"\n Band 5 : ", iBands (NULL,0,20,2,0,0,MODE_LOWER,0) 
    
   ); 
   */
   // SINGH END 

   return(0);
}
//+------------------------------------------------------------------+--------+